// -------------------------------------------------------------------------------
// 
// 		cwCu		R[h֌WvOwb_t@C
// 
// 				Ver 3.14a
// 
// -------------------------------------------------------------------------------

#ifndef __DXCHAR_H__
#define __DXCHAR_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#define DX_CODEPAGE_SHIFTJIS	(932)
#define DX_CODEPAGE_GB2312		(936)
#define DX_CODEPAGE_UHC			(949)
#define DX_CODEPAGE_BIG5		(950)
#define DX_CODEPAGE_UTF16LE		(1200)
#define DX_CODEPAGE_UTF16BE		(1201)
#define DX_CODEPAGE_ASCII		(1252)
#define DX_CODEPAGE_UTF8		(65001)
#define DX_CODEPAGE_UTF32LE		(32766)			// ȃR[ĥŏɒ`
#define DX_CODEPAGE_UTF32BE		(32767)			// ȃR[ĥŏɒ`

// VtgJISQoCg
#define CHECK_SHIFTJIS_2BYTE( x )			( ( BYTE )( ( ( ( BYTE )(x) ) ^ 0x20) - ( BYTE )0xa1 ) < 0x3c )

// UTF16LETQ[gyA( gGfBAp )
#define CHECK_CPU_LE_UTF16LE_4BYTE( x )		( ( ( x ) & 0xfc00 ) == 0xd800 )

// UTF16LETQ[gyA( rbOGfBAp )
#define CHECK_CPU_BE_UTF16LE_4BYTE( x )		( ( ( ( ( ( ( WORD )( x ) ) >> 8 ) & 0xff ) | ( ( ( WORD )( x ) << 8 ) & 0xff00 ) ) & 0xfc00 ) == 0xd800 )

// UTF16BETQ[gyA( gGfBAp )
#define CHECK_CPU_LE_UTF16BE_4BYTE( x )		CHECK_CPU_BE_UTF16LE_4BYTE( x )

// UTF16BETQ[gyA( rbOGfBAp )
#define CHECK_CPU_BE_UTF16BE_4BYTE( x )		CHECK_CPU_LE_UTF16LE_4BYTE( x )

// wchar_t TQ[gyA( UTF-32 or UTF-16 z )
#ifdef WCHAR_T_BE
	#define CHECK_WCHAR_T_DOUBLE( x )	( sizeof( wchar_t ) == 2 && ( ( ( WORD )( x ) & 0x00fc ) == 0x00d8 ) )
#else
	#define CHECK_WCHAR_T_DOUBLE( x )	( sizeof( wchar_t ) == 2 && ( ( ( WORD )( x ) & 0xfc00 ) == 0xd800 ) )
#endif

// \̒` --------------------------------------------------------------------

// UTF-16ƊeR[h̑Ή\̏
struct CHARCODETABLEINFO
{
	WORD				MultiByteToUTF16[ 0x10000 ] ;		// eR[hUTF-16ɕϊ邽߂̃e[u
	WORD				UTF16ToMultiByte[ 0x10000 ] ;		// UTF-16eR[hɕϊ邽߂̃e[u
} ;

// R[h֌WŎgp
struct CHARCODESYSTEM
{
	int					InitializeFlag ;					// sǂ( TRUE:s  FALSE:sĂȂ )

	CHARCODETABLEINFO	CharCodeCP932Info ;					// Shift-JIS̕R[h
	CHARCODETABLEINFO	CharCodeCP936Info ;					// GB2312̕R[h
	CHARCODETABLEINFO	CharCodeCP949Info ;					// UHC̕R[h
	CHARCODETABLEINFO	CharCodeCP950Info ;					// BIG5̕R[h
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern CHARCODESYSTEM g_CharCodeSystem ;

// ֐vg^Cv錾-----------------------------------------------------------

extern	int				InitCharCode( void ) ;																			// R[h֘Ȁs

extern	int				GetCodePageUnitSize(	int CodePage ) ;														// w̃R[hy[W̏ŏTCY擾( ߂lFoCg )
extern	int				GetCharBytes(			const char *CharCode, int CodePage ) ;									// P̃oCg擾( ߂lFP̃oCg )
extern	DWORD			GetCharCode(			const char *CharCode, int CodePage, int *CharBytes ) ;					// P̕R[hƕ̃oCg擾
extern	int				PutCharCode(			DWORD CharCode, int CodePage, char *Dest ) ;							// R[hʏ̕ɕϊAI[Ƀk͏܂Ȃ( ߂lF񂾃oCg )
extern	DWORD			ConvCharCode(			DWORD SrcCharCode, int SrcCodePage, int DestCodePage ) ;				// R[hw̃R[hy[W̕ɕϊ
extern	int				ConvCharCodeString(		const DWORD *Src, int SrcCodePage, DWORD *Dest, int DestCodePage ) ;	// PSoCg̔zAʃR[hy[ŴPSoCg̔zɕϊ( ߂lFϊ̃TCYAk܂( PʁFoCg ) )
extern	int				StringToCharCodeString( const char  *Src, int SrcCodePage, DWORD  *Dest ) ;						// PSoCg̔zɕϊ( ߂lFϊ̃TCYAk܂( PʁFoCg ) )
extern	int				CharCodeStringToString( const DWORD *Src, char *Dest, int DestCodePage ) ;						// PSoCg̔z𕶎ɕϊ( ߂lFϊ̃TCYAk܂( PʁFoCg ) )
extern	int				ConvString(				const char *Src, int SrcCodePage, char *Dest, int DestCodePage ) ;		// w̃R[hy[W̕ɕϊ( ߂lFϊ̃TCYAk܂( PʁFoCg ) )
extern	int				GetStringCharNum(		const char *String, int CodePage ) ;									// Ɋ܂܂镶擾
extern	const char *	GetStringCharAddress(	const char *String, int CodePage, int Index ) ;							// wԍ̃̕AhX擾
extern	DWORD			GetStringCharCode(		const char *String, int CodePage, int Index ) ;							// wԍ̃̕R[h擾

extern	void			CL_strcpy(            int CodePage, char *Dest, const char *Src ) ;
extern	void			CL_strncpy(           int CodePage, char *Dest, const char *Src, int Num ) ;
extern	void			CL_strcat(            int CodePage, char *Dest, const char *Src ) ;
extern	const char *	CL_strstr(            int CodePage, const char *Str1, const char *Str2 ) ;
extern	int				CL_strlen(            int CodePage, const char *Str ) ;
extern	int				CL_strcmp(            int CodePage, const char *Str1, const char *Str2 ) ;
extern	int				CL_stricmp(           int CodePage, const char *Str1, const char *Str2 ) ;
extern	int				CL_strcmp_str2_ascii( int CodePage, const char *Str1, const char *Str2 ) ;
extern	int				CL_strncmp(           int CodePage, const char *Str1, const char *Str2, int Size ) ;
extern	const char *	CL_strchr(            int CodePage, const char *Str, DWORD CharCode ) ;
extern	const char *	CL_strrchr(           int CodePage, const char *Str, DWORD CharCode ) ;
extern	char *			CL_strupr(            int CodePage, char *Str ) ;
extern	int				CL_vsprintf(          int CodePage, int IsWChar, int CharCodePage, int WCharCodePage, char *Buffer, const char *FormatString, va_list Arg ) ;
extern	int				CL_sprintf(           int CodePage, int IsWChar, int CharCodePage, int WCharCodePage, char *Buffer, const char *FormatString, ... ) ;
extern	char *			CL_itoa(              int CodePage, int Value, char *Buffer, int Radix ) ;
extern	int				CL_atoi(              int CodePage, const char *Str ) ;
extern	double			CL_atof(              int CodePage, const char *Str ) ;
extern	int				CL_vsscanf(           int CodePage, int IsWChar, int CharCodePage, int WCharCodePage, const char *String, const char *FormatString, va_list Arg ) ;
extern	int				CL_sscanf(            int CodePage, int IsWChar, int CharCodePage, int WCharCodePage, const char *String, const char *FormatString, ... ) ;

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXCHAR_H__
